import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import quadbase.common.util.dtd.elements.DTDDataType;
import quadbase.common.util.internal.XMLDataTypeUtil;
import quadbase.common.util.internal.XMLFieldInfo;
import quadbase.common.util.internal.XMLFileQueryInfo;
import quadbase.reportdesigner.ReportAPI.QbReport;
import quadbase.reportdesigner.ReportViewer.Viewer;

public class SwitchToXMLData extends Applet {

	static final long serialVersionUID = 1;

	public static void main(String[] args) {
		try {
			SwitchToXMLData report = new SwitchToXMLData();
			Frame frame = new Frame();
			frame.setLayout(new BorderLayout());
			frame.add("Center", report.doSwitchToXMLData(frame));
			frame.addWindowListener(new WindowAdapter() {
				@Override
				public void windowClosing(WindowEvent e) {
					System.exit(0);
				}
			});
			frame.setSize(800, 600);
			frame.setVisible(true);

		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	@Override
	public void init() {
		setLayout(new BorderLayout());
		add("Center", doSwitchToXMLData(this));
	}

	Component doSwitchToXMLData(Object parent) {

		// Do not use EspressManager
		QbReport.setEspressManagerUsed(false);

		// Open the template with backup data
		QbReport report = new QbReport(parent, // container 
				"SwitchToXMLData.rpt", // template
				false, false, false, true);

		// XML data source information
		String xmlfilename = "Inventory.xml";
		String xmlcondition = "";
		XMLFieldInfo[] fields = new XMLFieldInfo[4];
		fields[0] = new XMLFieldInfo(new String[] { "Inventory", "Category", "Product",
				"ProductName" });
		fields[1] = new XMLFieldInfo(
				new String[] { "Inventory", "Category", "Product", "UnitPrice" });
		fields[1].setElementDataType(DTDDataType.DOUBLE);
		fields[2] = new XMLFieldInfo(new String[] { "Inventory", "Category", "Product",
				"UnitsInStock" });
		fields[2].setElementDataType(DTDDataType.INT);
		fields[3] = new XMLFieldInfo(
				new String[] { "Inventory", "Category", "Product", "ShipDate" });
		fields[3].setElementDataType(DTDDataType.DATE);
		fields[3].setDateFormat(XMLDataTypeUtil.YYYY_MM_DD);

		XMLFileQueryInfo xmlInfo = new XMLFileQueryInfo(xmlfilename, fields, xmlcondition, fields);

		try {
			// Switch data source
			report.getInputData().setXMLFileQueryInfo(xmlInfo);

			// Refresh report
			report.refresh();
		} catch (Exception ex)
		{
			ex.printStackTrace();

		}

		// Show report in Viewer
		return (new Viewer().getComponent(report));
	}
}
